#!/bin/sh
dirname=`dirname $0`
appname=`basename $0 | sed s,\.sh$,,`
dirname=`readlink -f $dirname`
envfile=`readlink -f $dirname/../data/var/env`

# display
if [ -f "$envfile" ]; then
  display=`cat "$envfile"|grep "^DISPLAY"|awk -F "=" '{print $2}'`
fi
if [ -z "$display" ]; then
  display=$(who |awk -v tty="$(cat /sys/class/tty/tty0/active)" '$2 == tty && $3 != "-" {print $5; exit}' |awk '{sub(/^\(*/,"");sub(/\)*$/,"")}1')
#  display=$(w -hs |awk -v tty="$(cat /sys/class/tty/tty0/active)" '$2 == tty && $3 != "-" {print $3; exit}')
fi
if [ -z "$display" ]; then
  display=`ls /tmp/.X11-unix/|grep -v X0|sed 's/X/:/g'|head -n 1`
fi
if [ -z "$display" ]; then
  display=:0
fi

# loginname
if [ -f "$envfile" ]; then
  loginname=`cat "$envfile"|grep "^USER"|awk -F "=" '{print $2}'`
fi
if [ -z "$loginname" ]; then
  loginname=$(who |awk -v tty="$(cat /sys/class/tty/tty0/active)" '$2 == tty && $3 != "-" {print $1; exit}')
fi
if [ -z "$loginname" ]; then
  loginname=`who |awk '{print $1}' |head -n 1`
fi
if [ -z "$loginname" ]; then
  loginname=`ps -aux |grep -E 'dde-desktop|gnome-keyring-daemon|peony-qt-desktop' |grep -v 'grep' |awk '{print $1}' |head -n 1`
fi

# loginhome
loginhome=`cat /etc/passwd |grep bash |grep $loginname: | awk -F: '{print $6}' |head -n 1`
if [ -z "$loginhome" ]; then
  loginhome=/home/$loginname
fi

# loginid
loginid=`cat /etc/passwd |grep bash |grep $loginname: | awk -F: '{print $3}' |head -n 1`
if [ -z "$loginid" ]; then
  loginid=1000
fi

# QT_IM_MODULE
qtim=ibus
if [ -f "/etc/X11/xinit/xinput.d/fcitx" ] ; then
  qtim=fcitx
fi 

# QT_QPA_PLATFORM
platform=xcb
if [ $(ps -ef |grep -w Xwayland|wc -l) -gt 1 ]; then
  export QT_WAYLAND_SHELL_INTEGRATION=kwayland-shell
  export QT_LOGGING_RULES=kwin*=true;kwin_libinput=false;
  export XDG_SESSION_TYPE=wayland
#  platform=wayland 中标麒麟QT_QPA_PLATFORM=wayland无法拖拽
fi

export XDG_RUNTIME_DIR=/run/user/$loginid
export LD_LIBRARY_PATH=$dirname/qt563
export DISPLAY=$display
export HOME=$loginhome
export QT_IM_MODULE=$qtim
export QT_QPA_PLATFORM=$platform
export LANG=zh_CN.UTF-8
xhost +

$dirname/qt563/"$@"
